
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2002, 2003, 2004, 2005, 2006, 2007, 2008 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

// Take the name prefix into account.
#define yylex   vcsnyylex

/* First part of user declarations.  */

/* Line 311 of lalr1.cc  */
#line 8 "krat_exp_bison.yy"

# include <vaucanson/algebra/implementation/series/krat_exp_parser_private.hh>
# include <map>
# include <queue>
# include <string>
# include <cassert>
//_DEBUG_
# include <iostream>


/* Line 311 of lalr1.cc  */
#line 54 "krat_exp_bison.tab.cc"


#include "krat_exp_bison.tab.hh"

/* User implementation prologue.  */

/* Line 317 of lalr1.cc  */
#line 32 "krat_exp_bison.yy"

int
yylex(vcsnyy::krat_exp_bison::semantic_type* yylval,
      std::queue<std::pair<vcsnyy::krat_exp_bison::token_type, vcsnyy::krat_exp_bison::semantic_type> >& tok_q);


/* Line 317 of lalr1.cc  */
#line 70 "krat_exp_bison.tab.cc"

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* Enable debugging if requested.  */
#if YYDEBUG

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define yyerrok		(yyerrstatus_ = 0)
#define yyclearin	(yychar = yyempty_)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


/* Line 380 of lalr1.cc  */
#line 1 "[Bison:b4_percent_define_default]"

namespace vcsnyy {

/* Line 380 of lalr1.cc  */
#line 139 "krat_exp_bison.tab.cc"
#if YYERROR_VERBOSE

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  krat_exp_bison::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

#endif

  /// Build a parser object.
  krat_exp_bison::krat_exp_bison (std::queue<std::pair<krat_exp_bison::token_type, krat_exp_bison::semantic_type> >& tok_q_yyarg, vcsn::algebra::krat_exp_virtual& exp_yyarg, std::string& error__yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      tok_q (tok_q_yyarg),
      exp (exp_yyarg),
      error_ (error__yyarg)
  {
  }

  krat_exp_bison::~krat_exp_bison ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  krat_exp_bison::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    switch (yytype)
      {
        case 3: /* "OPAR" */

/* Line 449 of lalr1.cc  */
#line 23 "krat_exp_bison.yy"
	{ debug_stream() << *(yyvaluep->str); };

/* Line 449 of lalr1.cc  */
#line 218 "krat_exp_bison.tab.cc"
	break;
      case 4: /* "CPAR" */

/* Line 449 of lalr1.cc  */
#line 23 "krat_exp_bison.yy"
	{ debug_stream() << *(yyvaluep->str); };

/* Line 449 of lalr1.cc  */
#line 227 "krat_exp_bison.tab.cc"
	break;
      case 5: /* "PLUS" */

/* Line 449 of lalr1.cc  */
#line 23 "krat_exp_bison.yy"
	{ debug_stream() << *(yyvaluep->str); };

/* Line 449 of lalr1.cc  */
#line 236 "krat_exp_bison.tab.cc"
	break;
      case 6: /* "TIMES" */

/* Line 449 of lalr1.cc  */
#line 23 "krat_exp_bison.yy"
	{ debug_stream() << *(yyvaluep->str); };

/* Line 449 of lalr1.cc  */
#line 245 "krat_exp_bison.tab.cc"
	break;
      case 10: /* "STAR" */

/* Line 449 of lalr1.cc  */
#line 23 "krat_exp_bison.yy"
	{ debug_stream() << *(yyvaluep->str); };

/* Line 449 of lalr1.cc  */
#line 254 "krat_exp_bison.tab.cc"
	break;
       default:
	  break;
      }
  }


  void
  krat_exp_bison::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif

  void
  krat_exp_bison::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
  
	default:
	  break;
      }
  }

  void
  krat_exp_bison::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  krat_exp_bison::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  krat_exp_bison::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  krat_exp_bison::debug_level_type
  krat_exp_bison::debug_level () const
  {
    return yydebug_;
  }

  void
  krat_exp_bison::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif

  int
  krat_exp_bison::parse ()
  {
    /// Lookahead and lookahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the lookahead.
    semantic_type yylval;
    /// Location of the lookahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location_type yyerror_range[2];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;

    /* Accept?  */
    if (yystate == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without lookahead.  */
    yyn = yypact_[yystate];
    if (yyn == yypact_ninf_)
      goto yydefault;

    /* Read a lookahead token.  */
    if (yychar == yyempty_)
      {
	YYCDEBUG << "Reading a token: ";
	yychar = yylex (&yylval, tok_q);
      }


    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yyn == 0 || yyn == yytable_ninf_)
	goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Shift the lookahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted.  */
    yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 2:

/* Line 678 of lalr1.cc  */
#line 54 "krat_exp_bison.yy"
    {exp = *(yysemantic_stack_[(1) - (1)].rexp); delete (yysemantic_stack_[(1) - (1)].rexp); }
    break;

  case 3:

/* Line 678 of lalr1.cc  */
#line 58 "krat_exp_bison.yy"
    {(yyval.rexp) = (yysemantic_stack_[(3) - (2)].rexp) ; delete (yysemantic_stack_[(3) - (1)].str); delete (yysemantic_stack_[(3) - (3)].str);}
    break;

  case 4:

/* Line 678 of lalr1.cc  */
#line 59 "krat_exp_bison.yy"
    {(yyval.rexp) = *(yysemantic_stack_[(3) - (1)].rexp) + (yysemantic_stack_[(3) - (3)].rexp); delete (yysemantic_stack_[(3) - (1)].rexp); delete (yysemantic_stack_[(3) - (2)].str); delete (yysemantic_stack_[(3) - (3)].rexp);}
    break;

  case 5:

/* Line 678 of lalr1.cc  */
#line 60 "krat_exp_bison.yy"
    {(yyval.rexp) = *(yysemantic_stack_[(3) - (1)].rexp) * (yysemantic_stack_[(3) - (3)].rexp); delete (yysemantic_stack_[(3) - (1)].rexp); delete (yysemantic_stack_[(3) - (2)].str); delete (yysemantic_stack_[(3) - (3)].rexp);}
    break;

  case 6:

/* Line 678 of lalr1.cc  */
#line 61 "krat_exp_bison.yy"
    {(yyval.rexp) = *(yysemantic_stack_[(2) - (1)].rexp) * (yysemantic_stack_[(2) - (2)].rexp); delete (yysemantic_stack_[(2) - (1)].rexp); delete (yysemantic_stack_[(2) - (2)].rexp);}
    break;

  case 7:

/* Line 678 of lalr1.cc  */
#line 62 "krat_exp_bison.yy"
    {(yysemantic_stack_[(2) - (1)].rexp)->star(); (yyval.rexp) = (yysemantic_stack_[(2) - (1)].rexp); delete (yysemantic_stack_[(2) - (2)].str);}
    break;

  case 8:

/* Line 678 of lalr1.cc  */
#line 63 "krat_exp_bison.yy"
    {(yysemantic_stack_[(2) - (2)].rexp)->left_weight((yysemantic_stack_[(2) - (1)].sem)); delete (yysemantic_stack_[(2) - (1)].sem); (yyval.rexp) = (yysemantic_stack_[(2) - (2)].rexp);}
    break;

  case 9:

/* Line 678 of lalr1.cc  */
#line 64 "krat_exp_bison.yy"
    {(yysemantic_stack_[(2) - (1)].rexp)->right_weight((yysemantic_stack_[(2) - (2)].sem)); delete (yysemantic_stack_[(2) - (2)].sem);(yyval.rexp) = (yysemantic_stack_[(2) - (1)].rexp);}
    break;

  case 10:

/* Line 678 of lalr1.cc  */
#line 65 "krat_exp_bison.yy"
    {(yyval.rexp) = (yysemantic_stack_[(1) - (1)].rexp);}
    break;

  case 11:

/* Line 678 of lalr1.cc  */
#line 66 "krat_exp_bison.yy"
    {(yyval.rexp) = (yysemantic_stack_[(1) - (1)].rexp);}
    break;



/* Line 678 of lalr1.cc  */
#line 547 "krat_exp_bison.tab.cc"
	default:
          break;
      }
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[0] = yylloc;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

	if (yychar <= yyeof_)
	  {
	  /* Return failure if at end of input.  */
	  if (yychar == yyeof_)
	    YYABORT;
	  }
	else
	  {
	    yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
	    yychar = yyempty_;
	  }
      }

    /* Else will try to reuse lookahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[0] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (yyn != yypact_ninf_)
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	YYABORT;

	yyerror_range[0] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    yyerror_range[1] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the lookahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyempty_)
      yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval, &yylloc);

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystate_stack_.height () != 1)
      {
	yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  krat_exp_bison::yysyntax_error_ (int yystate, int tok)
  {
    std::string res;
    YYUSE (yystate);
#if YYERROR_VERBOSE
    int yyn = yypact_[yystate];
    if (yypact_ninf_ < yyn && yyn <= yylast_)
      {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
	int count = 0;
	for (int x = yyxbegin; x < yyxend; ++x)
	  if (yycheck_[x + yyn] == x && x != yyterror_)
	    ++count;

	// FIXME: This method of building the message is not compatible
	// with internationalization.  It should work like yacc.c does it.
	// That is, first build a string that looks like this:
	// "syntax error, unexpected %s or %s or %s"
	// Then, invoke YY_ on this string.
	// Finally, use the string as a format to output
	// yytname_[tok], etc.
	// Until this gets fixed, this message appears in English only.
	res = "syntax error, unexpected ";
	res += yytnamerr_ (yytname_[tok]);
	if (count < 5)
	  {
	    count = 0;
	    for (int x = yyxbegin; x < yyxend; ++x)
	      if (yycheck_[x + yyn] == x && x != yyterror_)
		{
		  res += (!count++) ? ", expecting " : " or ";
		  res += yytnamerr_ (yytname_[x]);
		}
	  }
      }
    else
#endif
      res = YY_("syntax error");
    return res;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char krat_exp_bison::yypact_ninf_ = -1;
  const signed char
  krat_exp_bison::yypact_[] =
  {
        42,    42,    42,    -1,    -1,     3,    20,    10,    46,    -1,
      42,    42,    40,    -1,    36,    -1,    30,    36
  };

  /* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
     doesn't specify something else to do.  Zero means the default is an
     error.  */
  const unsigned char
  krat_exp_bison::yydefact_[] =
  {
         0,     0,     0,    10,    11,     0,     2,     0,     8,     1,
       0,     0,     9,     7,     6,     3,     4,     5
  };

  /* YYPGOTO[NTERM-NUM].  */
  const signed char
  krat_exp_bison::yypgoto_[] =
  {
        -1,    -1,     0
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const signed char
  krat_exp_bison::yydefgoto_[] =
  {
        -1,     5,    14
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If zero, do what YYDEFACT says.  */
  const signed char krat_exp_bison::yytable_ninf_ = -1;
  const unsigned char
  krat_exp_bison::yytable_[] =
  {
         6,     7,     8,     9,     0,     0,     0,     0,     0,     0,
      16,    17,     8,     1,    15,    10,    11,     0,    12,     0,
      13,     3,     4,     1,     0,    10,    11,     0,    12,     0,
      13,     3,     4,     1,     0,     0,    11,     0,    12,     1,
      13,     3,     4,     1,    12,     1,    13,     3,     4,     1,
       2,     3,     4,     3,     4,     0,    13,     3,     4
  };

  /* YYCHECK.  */
  const signed char
  krat_exp_bison::yycheck_[] =
  {
         0,     1,     2,     0,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    11,    12,     3,     4,     5,     6,    -1,     8,    -1,
      10,    11,    12,     3,    -1,     5,     6,    -1,     8,    -1,
      10,    11,    12,     3,    -1,    -1,     6,    -1,     8,     3,
      10,    11,    12,     3,     8,     3,    10,    11,    12,     3,
       8,    11,    12,    11,    12,    -1,    10,    11,    12
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  krat_exp_bison::yystos_[] =
  {
         0,     3,     8,    11,    12,    14,    15,    15,    15,     0,
       5,     6,     8,    10,    15,     4,    15,    15
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  krat_exp_bison::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  krat_exp_bison::yyr1_[] =
  {
         0,    13,    14,    15,    15,    15,    15,    15,    15,    15,
      15,    15
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  krat_exp_bison::yyr2_[] =
  {
         0,     2,     1,     3,     3,     3,     2,     2,     2,     2,
       1,     1
  };

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const krat_exp_bison::yytname_[] =
  {
    "$end", "error", "$undefined", "OPAR", "CPAR", "PLUS", "TIMES",
  "TIMES2", "WEIGHT", "LPROD", "STAR", "ZERO", "WORD", "$accept", "exp",
  "rexp", 0
  };
#endif

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const krat_exp_bison::rhs_number_type
  krat_exp_bison::yyrhs_[] =
  {
        14,     0,    -1,    15,    -1,     3,    15,     4,    -1,    15,
       5,    15,    -1,    15,     6,    15,    -1,    15,    15,    -1,
      15,    10,    -1,     8,    15,    -1,    15,     8,    -1,    11,
      -1,    12,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned char
  krat_exp_bison::yyprhs_[] =
  {
         0,     0,     3,     5,     9,    13,    17,    20,    23,    26,
      29,    31
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned char
  krat_exp_bison::yyrline_[] =
  {
         0,    54,    54,    58,    59,    60,    61,    62,    63,    64,
      65,    66
  };

  // Print the state stack on the debug stream.
  void
  krat_exp_bison::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  krat_exp_bison::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "):" << std::endl;
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  krat_exp_bison::token_number_type
  krat_exp_bison::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int krat_exp_bison::yyeof_ = 0;
  const int krat_exp_bison::yylast_ = 58;
  const int krat_exp_bison::yynnts_ = 3;
  const int krat_exp_bison::yyempty_ = -2;
  const int krat_exp_bison::yyfinal_ = 9;
  const int krat_exp_bison::yyterror_ = 1;
  const int krat_exp_bison::yyerrcode_ = 256;
  const int krat_exp_bison::yyntokens_ = 13;

  const unsigned int krat_exp_bison::yyuser_token_number_max_ = 267;
  const krat_exp_bison::token_number_type krat_exp_bison::yyundef_token_ = 2;


/* Line 1054 of lalr1.cc  */
#line 1 "[Bison:b4_percent_define_default]"

} // vcsnyy

/* Line 1054 of lalr1.cc  */
#line 977 "krat_exp_bison.tab.cc"


/* Line 1056 of lalr1.cc  */
#line 69 "krat_exp_bison.yy"


namespace vcsnyy
{
  struct token_queue
  {
    std::queue
    <
      std::pair
      <
	krat_exp_bison::token_type,
	krat_exp_bison::semantic_type
      >
    > self;
  };
} // vcsnyy

vcsnyy::krat_exp_parser::krat_exp_parser()
{
  tok_q_ = new token_queue;
}

vcsnyy::krat_exp_parser::~krat_exp_parser()
{
  delete tok_q_;
}

void
vcsnyy::krat_exp_parser::insert_word(vcsn::algebra::krat_exp_virtual* rexp)
{
  krat_exp_bison::semantic_type tmp;
  tmp.rexp = rexp;
  tok_q_->self.push(std::make_pair(krat_exp_bison::token::WORD, tmp));
}

void
vcsnyy::krat_exp_parser::insert_weight(vcsn::algebra::semiring_virtual* sem)
{
  krat_exp_bison::semantic_type tmp;
  tmp.sem = sem;
  tok_q_->self.push(std::make_pair(krat_exp_bison::token::WEIGHT, tmp));
}

void
vcsnyy::krat_exp_parser::insert_zero(vcsn::algebra::krat_exp_virtual* rexp)
{
  krat_exp_bison::semantic_type tmp;
  tmp.rexp = rexp;
  tok_q_->self.push(std::make_pair(krat_exp_bison::token::ZERO, tmp));
}

void
vcsnyy::krat_exp_parser::insert_token(int i, std::string* str)
{
  krat_exp_bison::semantic_type tmp;
  tmp.str = str;
  switch (i)
  {
    case 0 :
      tok_q_->self.push(std::make_pair(krat_exp_bison::token::OPAR, tmp));
      break;
    case 1 :
      tok_q_->self.push(std::make_pair(krat_exp_bison::token::CPAR, tmp));
      break;
    case 2 :
      tok_q_->self.push(std::make_pair(krat_exp_bison::token::PLUS, tmp));
      break;
    case 3 :
      tok_q_->self.push(std::make_pair(krat_exp_bison::token::TIMES, tmp));
      break;
    case 4 :
      tok_q_->self.push(std::make_pair(krat_exp_bison::token::STAR, tmp));
      break;
    default : // this step should never append
      assert(false);
      break;
  }
}

int
vcsnyy::krat_exp_parser::parse(vcsn::algebra::krat_exp_virtual& rexp_, std::string& error_)
{
  vcsnyy::krat_exp_bison parser(tok_q_->self , rexp_, error_);
#if YYDEBUG
  parser.set_debug_level(true);
#endif
  return parser.parse();
}

int
vcsnyylex(vcsnyy::krat_exp_bison::semantic_type* yylval,
      std::queue<std::pair<vcsnyy::krat_exp_bison::token_type, vcsnyy::krat_exp_bison::semantic_type> >& tok_q)
{
  vcsnyy::krat_exp_bison::token_type res;
  if (tok_q.empty())
    return 0;
  else
  {
    *yylval = tok_q.front().second;
    res = tok_q.front().first;
    tok_q.pop();
    return res;
  }
}

void
vcsnyy::krat_exp_bison::error(const vcsnyy::krat_exp_bison::location_type& loc, const std::string& s)
{
  error_ += s + '\n';
}

